=== debian/changelog ===
xtl (0.6.9-1) unstable; urgency=medium

  * Initial release (Closes: #939936)

 -- Vincent Bernat <bernat@debian.org>  Sat, 14 Dec 2019 18:27:18 +0100
