=== debian/control ===
Source: xtl
Priority: optional
Maintainer: Debian QuantStack Team <team+debian-quantstack-team@tracker.debian.org>
Uploaders: Vincent Bernat <bernat@debian.org>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libgtest-dev (>= 1.8.1)
Standards-Version: 4.4.0
Section: libs
Homepage: https://github.com/QuantStack/xtl
Vcs-Browser: https://github.com/quantstack-debian/xtl
Vcs-Git: https://github.com/quantstack-debian/xtl.git

Package: xtl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Description: basic tools (containers, algorithms) used for xtensor and xeus
 This package contains additional containers and tools missing from
 STL C++14. This library is header-only.
