=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%xtl-$1.tar.gz%" \
   https://github.com/QuantStack/xtl/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
