## xtl 0.6.21

=== debian/changelog ===
xtl (0.6.21-1) unstable; urgency=medium

  [ Gordon Ball ]
  * New upstream version: 0.6.21
  * Make xtl-dev arch:all. As this is a header-only library (+cmake and
    pkg-config metadata), installing to arch-dependent tasks and duplicating
    the package can be avoided. This moves the metadata from usr/lib/tuple to
    usr/share.
  * Patch out use of -march=native in tests. This didn't affect the result
    (since there was no compiled object in the package), but generated build
    log scanning errors. (Closes: #961402)
  * Update Standards-Version to 4.5.0
  * Declare Rules-Requires-Root: no
  * Update homepage to github.com/xtensor-stack/xtl

  [ Vincent Bernat ]
  * Prepare for release

 -- Vincent Bernat <bernat@debian.org>  Sun, 22 Nov 2020 16:02:55 +0100
