=== debian/changelog ===
xtl (0.6.23-1) unstable; urgency=medium

  * New upstream version 0.6.23
  * Update patches
    - Drop 0001-Install-cmake-pkgconfig-in-usr-share.patch, upstreamed
    - Patch a failing test in test_xsystem due to assumptions about the
      build directory naming
  * Run the test suite as an autopkgtest

 -- Gordon Ball <gordon@chronitis.net>  Tue, 12 Jan 2021 12:35:53 +0000
