=== debian/tests/control ===
Test-Command: cd test && cmake -DGTEST_SRC_DIR=/usr/src/gtest . && make && make test
Depends: xtl-dev, cmake, libgtest-dev, g++
Restrictions: allow-stderr
