## xtl 0.7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,8 +9,6 @@
 
 cmake_minimum_required(VERSION 3.1)
 project(xtl)
-
-enable_testing()
 
 set(XTL_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
 
@@ -31,7 +29,9 @@
 # Dependencies
 # ============
 
-find_package(nlohmann_json QUIET)
+if(NOT TARGET nlohmann_json)
+    find_package(nlohmann_json QUIET)
+endif()
 
 # Build
 # =====
@@ -47,6 +47,8 @@
     ${XTL_INCLUDE_DIR}/xtl/xspan_impl.hpp
     ${XTL_INCLUDE_DIR}/xtl/xdynamic_bitset.hpp
     ${XTL_INCLUDE_DIR}/xtl/xfunctional.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xhalf_float.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xhalf_float_impl.hpp
     ${XTL_INCLUDE_DIR}/xtl/xhash.hpp
     ${XTL_INCLUDE_DIR}/xtl/xhierarchy_generator.hpp
     ${XTL_INCLUDE_DIR}/xtl/xiterator_base.hpp
@@ -54,24 +56,34 @@
     ${XTL_INCLUDE_DIR}/xtl/xmasked_value_meta.hpp
     ${XTL_INCLUDE_DIR}/xtl/xmasked_value.hpp
     ${XTL_INCLUDE_DIR}/xtl/xmeta_utils.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xmultimethods.hpp
     ${XTL_INCLUDE_DIR}/xtl/xoptional_meta.hpp
     ${XTL_INCLUDE_DIR}/xtl/xoptional.hpp
     ${XTL_INCLUDE_DIR}/xtl/xoptional_sequence.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xplatform.hpp
     ${XTL_INCLUDE_DIR}/xtl/xproxy_wrapper.hpp
     ${XTL_INCLUDE_DIR}/xtl/xsequence.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xsystem.hpp
     ${XTL_INCLUDE_DIR}/xtl/xtl_config.hpp
     ${XTL_INCLUDE_DIR}/xtl/xtype_traits.hpp
     ${XTL_INCLUDE_DIR}/xtl/xvariant.hpp
     ${XTL_INCLUDE_DIR}/xtl/xvariant_impl.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xvisitor.hpp
 )
 
 add_library(xtl INTERFACE)
-target_include_directories(xtl INTERFACE $<BUILD_INTERFACE:${XTL_INCLUDE_DIR}>
-                                         $<INSTALL_INTERFACE:include>)
 
-# xtl requires C++14 support!
+target_include_directories(xtl INTERFACE
+    $<BUILD_INTERFACE:${XTL_INCLUDE_DIR}>
+    $<INSTALL_INTERFACE:include>)
+
+if(NOT (CMAKE_VERSION VERSION_LESS 3.15))  # CMake >= 3.15
+set_target_properties(xtl
+    PROPERTIES
+    PUBLIC_HEADER "${XTL_HEADERS}")
+endif()
+
 target_compile_features(xtl INTERFACE cxx_std_14)
-
 
 option(BUILD_TESTS "xtl test suite" OFF)
 option(DOWNLOAD_GTEST "build gtest from downloaded sources" OFF)
@@ -82,6 +94,7 @@
 endif()
 
 if(BUILD_TESTS)
+    enable_testing()
     add_subdirectory(test)
 endif()
 
@@ -91,17 +104,25 @@
 include(GNUInstallDirs)
 include(CMakePackageConfigHelpers)
 
+if(CMAKE_VERSION VERSION_LESS 3.15)  # CMake < 3.15
 install(TARGETS xtl
         EXPORT ${PROJECT_NAME}-targets)
+else()
+install(TARGETS xtl
+        EXPORT ${PROJECT_NAME}-targets
+        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})
+endif()
 
 # Makes the project importable from the build directory
 export(EXPORT ${PROJECT_NAME}-targets
        FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")
 
+if(CMAKE_VERSION VERSION_LESS 3.15)  # CMake < 3.15
 install(FILES ${XTL_HEADERS}
         DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xtl)
+endif()
 
-set(XTL_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE
+set(XTL_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/cmake/${PROJECT_NAME}" CACHE
     STRING "install path for xtlConfig.cmake")
 
 configure_package_config_file(${PROJECT_NAME}Config.cmake.in
@@ -113,9 +134,17 @@
 # generated for a 64 bit target can be used for 32 bit targets and vice versa.
 set(_XTL_CMAKE_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})
 unset(CMAKE_SIZEOF_VOID_P)
-write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
-                                 VERSION ${${PROJECT_NAME}_VERSION}
-                                 COMPATIBILITY AnyNewerVersion)
+# ARCH_INDEPENDENT feature was introduced in cmake 3.14
+if (${CMAKE_VERSION} VERSION_LESS "3.14.0")
+    write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
+                                     VERSION ${${PROJECT_NAME}_VERSION}
+                                     COMPATIBILITY AnyNewerVersion)
+else ()
+    write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
+                                     VERSION ${${PROJECT_NAME}_VERSION}
+                                     COMPATIBILITY AnyNewerVersion
+                                     ARCH_INDEPENDENT)
+endif ()
 set(CMAKE_SIZEOF_VOID_P ${_XTL_CMAKE_SIZEOF_VOID_P})
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
@@ -128,4 +157,4 @@
                "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
                 @ONLY)
 install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
-        DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")
+        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig/")
