=== debian/changelog ===
xtl (0.7.2-2~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 13 Sep 2022 16:55:07 -0700

xtl (0.7.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Vincent Bernat <bernat@debian.org>  Sat, 09 Oct 2021 17:26:03 +0200

xtl (0.7.2-1) experimental; urgency=medium

  * New upstream version. Closes: #984872.
  * d/patches: drop -march=native patch
  * d/patches: remove patch for broken test, fixed upstream

 -- Vincent Bernat <bernat@debian.org>  Tue, 09 Mar 2021 21:25:23 +0100
