=== debian/control ===
Source: xtl
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian QuantStack Team <team+debian-quantstack-team@tracker.debian.org>
Uploaders: Vincent Bernat <bernat@debian.org>
Build-Depends: cmake, debhelper-compat (= 12), libgtest-dev (>= 1.8.1)
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/xtensor-stack/xtl
Vcs-Browser: https://github.com/quantstack-debian/xtl
Vcs-Git: https://github.com/quantstack-debian/xtl.git
Rules-Requires-Root: no

Package: xtl-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}
Description: basic tools (containers, algorithms) used for xtensor and xeus
 This package contains additional containers and tools missing from
 STL C++14. This library is header-only.
