=== debian/tests/control ===
Test-Command: cd test && cmake -DGTEST_SRC_DIR=/usr/src/gtest . && make && make test
Depends: cmake, g++, libgtest-dev, xtl-dev
Restrictions: allow-stderr
