## xtl 0.7.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,6 +41,7 @@
     ${XTL_INCLUDE_DIR}/xtl/xbasic_fixed_string.hpp
     ${XTL_INCLUDE_DIR}/xtl/xbase64.hpp
     ${XTL_INCLUDE_DIR}/xtl/xclosure.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xcompare.hpp
     ${XTL_INCLUDE_DIR}/xtl/xcomplex.hpp
     ${XTL_INCLUDE_DIR}/xtl/xcomplex_sequence.hpp
     ${XTL_INCLUDE_DIR}/xtl/xspan.hpp
@@ -88,10 +89,6 @@
 option(BUILD_TESTS "xtl test suite" OFF)
 option(DOWNLOAD_GTEST "build gtest from downloaded sources" OFF)
 option(XTL_DISABLE_EXCEPTIONS "Disable C++ exceptions" OFF)
-
-if(DOWNLOAD_GTEST OR GTEST_SRC_DIR)
-    set(BUILD_TESTS ON)
-endif()
 
 if(BUILD_TESTS)
     enable_testing()
