=== debian/changelog ===
xtl (0.7.5-3) unstable; urgency=medium

  * d/test: add missing xtl-dev dependency. Closes: #1052544.
  * d/patches: add patch to fix test/CMakeLists.txt.

 -- Vincent Bernat <bernat@debian.org>  Wed, 04 Oct 2023 10:53:52 +0200

xtl (0.7.5-2) unstable; urgency=medium

  * Upload to unstable.

 -- Vincent Bernat <bernat@debian.org>  Sat, 23 Sep 2023 16:30:07 +0200

xtl (0.7.5-1) experimental; urgency=medium

  * New upstream version. Closes: #1029992.

 -- Vincent Bernat <bernat@debian.org>  Thu, 02 Feb 2023 20:37:04 +0100
