=== debian/changelog ===
xtl (0.7.7-1) unstable; urgency=medium

  * New upstream release. Closes: #1082757.

 -- Vincent Bernat <bernat@debian.org>  Mon, 30 Sep 2024 09:19:09 +0200
