=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: xtl
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Debian QuantStack Team <team+debian-quantstack-team@tracker.debian.org>
+Maintainer: Debian QuantStack Team <team+debian-quantstack-team@tracker.debian.org>
 Uploaders: Vincent Bernat <bernat@debian.org>
-Build-Depends: cmake, debhelper-compat (= 12), libgtest-dev (>= 1.8.1)
+Build-Depends: debhelper-compat (= 12),
+               cmake,
+               libgtest-dev (>= 1.8.1)
 Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/xtensor-stack/xtl
