## xtl 0.8.1

=== debian/changelog ===
xtl (0.8.1-1~0.1) unstable; urgency=medium

  * NMU upload.
  * New upstream release. Closes: #1101777
    - supports cmake 4. Closes: #1125675
    - drops include/xtl/xvariant_impl.hpp and xany.hpp
      (update debian/copyright)
  * mark xtl-dev Multi-Arch: foreign. Closes: #1112685
  * update debian/watch to v5 GitHub template

 -- Drew Parsons <dparsons@debian.org>  Sun, 08 Feb 2026 11:11:44 +0100
