=== debian/control ===
--- 
+++ 
@@ -15,6 +15,7 @@
 Package: xtl-dev
 Section: libdevel
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: basic tools (containers, algorithms) used for xtensor and xeus
  This package contains additional containers and tools missing from
