=== debian/watch ===
Version: 5

Template: GitHub
Owner: xtensor-stack
Project: xtl
