## xtl 0.8.2

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # The full license is in the file LICENSE, distributed with this software. #
 ############################################################################
 
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.29)
 
 find_package(doctest            REQUIRED)
 
@@ -37,7 +37,7 @@
 endif()
 
 if(CMAKE_CXX_COMPILER_ID MATCHES GNU OR CMAKE_CXX_COMPILER_ID MATCHES Intel)
-    add_compile_options(-Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion)
+    add_compile_options(-Werror -Wall -Wextra -Wconversion -Wsign-conversion $<$<AND:$<CXX_COMPILER_ID:GNU>,$<VERSION_LESS:$<CXX_COMPILER_VERSION>,12>>:-Wno-stringop-overflow>)
 
     if(NOT CMAKE_CXX_FLAGS MATCHES "-march")
         CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
@@ -60,7 +60,7 @@
 
 if(CMAKE_CXX_COMPILER_ID MATCHES Clang)
   if(NOT WIN32)
-    add_compile_options(-Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion)
+    add_compile_options(-Werror -Wall -Wextra -Wconversion -Wsign-conversion)
 
     if(NOT CMAKE_CXX_FLAGS MATCHES "-march")
         CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
@@ -93,7 +93,7 @@
     test_xfunctional.cpp
     test_xhalf_float.cpp
     test_xhash.cpp
-    test_xhierarchy_generator.cpp
+    # test_xhierarchy_generator.cpp
     test_xiterator_base.cpp
     test_xmasked_value.cpp
     test_xmeta_utils.cpp
@@ -104,7 +104,6 @@
     test_xplatform.cpp
     test_xproxy_wrapper.cpp
     test_xsystem.cpp
-    test_xvariant.cpp
     test_xvisitor.cpp
 )
