=== debian/changelog ===
xtl (0.8.2-1~0.1) unstable; urgency=medium

  * NMU upload.
  * New upstream release
  * Standards-Version: 4.7.3

 -- Drew Parsons <dparsons@debian.org>  Tue, 24 Feb 2026 10:54:59 +0100
